{***************************************************************************}
{  Date: 24.10.98                                            Time: 17:30:40 }
{  Copyright (c)1996-1998                                                   }
{   by Dr.Plass                                     Demo for  TFindProc4.0 }
{                                                                           }
{                                              for DELPHI3/4,      Win95/98 }
{  feel free to contact me:                                                 }
{  PP@FH-Zwickau.de                                                         }
{  http://www.fh-zwickau.de/~pp/tm.htm                                      }
{                                                                           }
{  All Rights Reserved.                                                     }
{  This component can be freely used and distributed in commercial and      }
{  private environments, provided this notice is not modified in any way.   }
{                                                                           }
{                                                                           }
{***************************************************************************}

unit FFindProc;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  FindProc, StdCtrls, Buttons, ExtCtrls, FileCtrl, Menus;

type
  TForm1 = class(TForm)
    BitBtn1: TBitBtn;
    ListBox1: TListBox;
    ListBox2: TListBox;
    BitBtn2: TBitBtn;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    ProcList1: TProcList;
    BitBtn3: TBitBtn;
    Image1: TImage;
    Image2: TImage;
    Label18: TLabel;
    Label22: TLabel;
    Label13: TLabel;
    Label21: TLabel;
    PopupMenu1: TPopupMenu;
    PopupMenu2: TPopupMenu;
    CancelProcess1: TMenuItem;
    DeleteModule1: TMenuItem;
    Refresh1: TMenuItem;
    About1: TMenuItem;
    N1: TMenuItem;
    Programmabbruch1: TMenuItem;
    Refresh2: TMenuItem;
    About2: TMenuItem;
    N2: TMenuItem;
    Programmabbruch2: TMenuItem;
    Label23: TLabel;
    StaticText1: TStaticText;
    procedure BitBtn1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure ListBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ListBox2MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BitBtn3Click(Sender: TObject);
    procedure CancelProcess1Click(Sender: TObject);
    procedure LBox1;
    procedure LBox2;
    procedure ListBox1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ListBox2KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormShow(Sender: TObject);
    procedure DeleteModule1Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;
  ico  : TIcon;
implementation

{$R *.DFM}

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
 ListBox1.Clear;
 ListBox2.Clear;
 Image1.Picture.Icon := nil;
 Image2.Picture.Icon := nil;
 Label3.Caption := ''; Label14.Caption :='';
 Label5.Caption := 'click an item for process information';
 Label6.Caption := ''; Label7.Caption  := '';
 Label8.Caption := ''; Label9.Caption  := '';
 Label10.Caption:= ''; Label11.Caption := '';
 Label12.Caption:= ''; Label13.Caption := '';
 Label4.Caption := ''; Label15.Caption := '';
 Label16.Caption:= ''; Label17.Caption := '';
 Label19.Caption:= '';
 Label20.Caption:= ''; Label21.Caption:= '';
 Label18.Caption := '';Label22.Caption := '';
 with ProcList1 do begin
  GetProcessInfo;
  ListBox1.Items.Assign(ProcessList);
  ListBox1.ItemIndex := 0;
  Label3.Caption := IntToStr(ProcessList.Count)+ ' running processes found';
  FormShow(sender);
 end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 Caption := ProcList1.About;
 BitBtn1Click(Sender);
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
 if ico <> nil then ico.free;
 close;
end;

procedure TForm1.ListBox1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  LBox1;
end;

procedure TForm1.ListBox2MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 LBox2;
end;
procedure TForm1.BitBtn3Click(Sender: TObject);
begin
 MessageDlg('Demosoftware'+ #10#13+
            'zur Komponente: TFindProc4.0         '+ #10#13+ #10#13+
            ' 1996-1998 by Dr.Peter Plass        '+ #10#13+
            'PP@fh-zwickau.de                     '+ #10#13+
            'http://www.fh-zwickau.de/~pp/tm.htm  ',
             mtInformation, [mbOk],0);
end;

procedure TForm1.CancelProcess1Click(Sender: TObject);
const
 PROCESS_TERMINATE = 1;
var
 ProcHandle: THandle;
begin
  if (ListBox1.Items.count < 1) OR (ListBox1.ItemIndex < 0) then exit;
  if (MessageDlg('Process: --> ' + ListBox1.Items[ListBox1.itemIndex]+ #10#13#10#13+
                 'TerminateProcess may lead the System into an instable state.'+#10#13+
                 'You should use this function only if you are sure about doing so.'+#10#13+
                 'Are You sure?', mtConfirmation, [mbYes, mbNo], 0) = mrYes)
  then begin
    ProcHandle := OpenProcess(PROCESS_TERMINATE, FALSE, DWORD(ProcList1.GetP_ID(ListBox1.ItemIndex)));
    try
     if ProcHandle <> 0 then begin
      if TerminateProcess(ProcHandle, $FFFFFFFF) then
       WaitForSingleObject(ProcHandle, INFINITE);
      end else
       MessageDlg('Can not find the handle of the selected process!', mtError, [mbOK], 0);
    finally
     CloseHandle(ProcHandle);
    end;
     BitBtn1Click(Sender);
  end;
end;

procedure TForm1.ListBox1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 LBox1;
end;

procedure TForm1.LBox1;
begin
if (ListBox1.Items.count < 1) OR (ListBox1.ItemIndex < 0) then exit;
  ListBox2.Clear;
  ico := TIcon.Create;
  ListBox1.Refresh;
  ico.Handle := ProcList1.GetP_IconHandle(ListBox1.ItemIndex);
  Image1.Picture.Icon := nil;
  Image2.Picture.Icon := nil;
  Label14.Caption := 'click an item for module information';
  Label15.Caption := '';   Label16.Caption := '';
  Label17.Caption := '';   Label19.Caption := '';
  Label20.Caption := '';
  Label21.Caption := '';   Label22.Caption := '';

 with ProcList1 do begin
  Label5.Caption := 'CntUsage: '  + IntToStr(GetP_CountUsage(ListBox1.ItemIndex));
  Label6.Caption := 'ProcessID: ' + IntToHex(GetP_ID(ListBox1.ItemIndex),8);
  Label7.Caption := 'DefHeapID: ' + IntToHex(GetP_defHeap(ListBox1.ItemIndex),8);
  Label8.Caption := 'ModuleID: '  + IntToHex(GetP_ModuleID(ListBox1.ItemIndex),8);
  Label9.caption := 'CntThreads: '+ IntToStr(GetP_CountThreads(ListBox1.ItemIndex));
  Label10.caption:= 'ParentID: '  + IntToHex(GetP_ParentPID(ListBox1.ItemIndex),8);
  Label11.caption:= 'Priority: '  + IntToStr(GetP_Priority(ListBox1.ItemIndex))+
  ' '+GetP_PrioStr(ListBox1.ItemIndex)+' '+GetP_BinTyp(ListBox1.ItemIndex);
  Label12.Caption:= 'dwFlags: '   + IntToStr(GetP_dwFlags(ListBox1.ItemIndex));
  Label13.Caption:= MinimizeName(GetP_ExePath(ListBox1.ItemIndex),Canvas,Label13.Width);
  Label18.Caption := 'HIcon: '    + IntToHex(GetP_IconHandle(ListBox1.ItemIndex),4);
  Image1.Picture.Icon := ico;
  GetModuleInfo(GetP_ID(ListBox1.ItemIndex));
  ListBox2.Items.Assign(ModuleList);
  ListBox2.ItemIndex := 0;
  Label4.Caption := IntToStr(ModuleList.Count)+ ' module(s) found';
  Lbox2;
 end;
end;

procedure TForm1.ListBox2KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 LBox2;
end;

Procedure TForm1.LBox2;
begin
 if (ListBox2.Items.count < 1) OR (ListBox2.ItemIndex < 0) then exit;
 ico := TIcon.Create;
 ico.Handle := ProcList1.GetM_IconHandle(ListBox2.ItemIndex);
 Image2.Picture.Icon := ico;
 with ProcList1 do begin
  Label22.Caption := 'HIcon: '      + IntToHex(GetM_IconHandle(ListBox2.ItemIndex),4);
  Label14.Caption := 'ModuleID: '   + IntToHex(GetM_ModuleID(ListBox2.ItemIndex),8);
  Label15.Caption := 'ProcessID: '  + IntToHex(GetM_ProcessID(ListBox2.ItemIndex),8);
  Label16.Caption := 'GlblCntUse: ' + IntToStr(GetM_GlblcntUsage(ListBox2.ItemIndex));
  Label17.Caption := 'ProcCntUse: ' + IntToStr(GetM_ProccntUsage(ListBox2.ItemIndex));
  Label19.caption := 'modBaseSize: '+ IntToStr(GetM_modBaseSize(ListBox2.ItemIndex));
  Label23.caption := 'mBaseAdress: '+ IntToHex(GetM_modBaseAddr(ListBox2.ItemIndex),8);
  Label20.caption := 'hModule: '    + IntToHex(GetM_hModule(ListBox2.ItemIndex),8);
  Label21.Caption:= MiniMizeName(GetM_szExePath(ListBox2.ItemIndex),Canvas,Label21.Width);
 end;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
 Lbox1;
 Lbox2;
end;

procedure TForm1.DeleteModule1Click(Sender: TObject);
var
hModLib,test:HModule;
begin
if (ListBox1.Items.count < 1) OR (ListBox1.ItemIndex < 0) then exit;
 if (MessageDlg('Module: --> ' + ListBox2.Items[ListBox2.itemIndex]+ #10#13#10#13+
                 'FreeLibrary may lead the system into an instable state.'+#10#13+
                 'You should use this function only if you are sure about doing so.'+#10#13+
                 'Are You sure?', mtConfirmation, [mbYes, mbNo], 0) = mrYes)
  then begin
    hModLib := ProcList1.GetM_hModule(ListBox2.ItemIndex);
    try
     test:=GetModuleHandle(PChar(ProcList1.GetM_szExePath(ListBox2.ItemIndex)));
     if (hModLib <> 0) AND (hModlib = test) AND FreeLibrary(hModLib)
     then BitBtn1Click(Sender)
     else MessageDlg('Can not delete the selected module!', mtError, [mbOK], 0);
    finally
    end;
  end;
end;

end.
